apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "capi-rancher-import.fullname" . }}
  labels:
    {{- include "capi-rancher-import.labels" . | nindent 4 }}
spec:
  {{- if not .Values.autoscaling.enabled }}
  replicas: {{ .Values.replicaCount }}
  {{- end }}
  selector:
    matchLabels:
      {{- include "capi-rancher-import.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      {{- with .Values.podAnnotations }}
      annotations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      labels:
        {{- include "capi-rancher-import.selectorLabels" . | nindent 8 }}
      annotations:
        checksum/script: {{ include (print $.Template.BasePath "/configmap.yaml") . | sha256sum }}
    spec:
      {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ include "capi-rancher-import.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      volumes:
        - name: python-script
          configMap:
            name:  {{ include "capi-rancher-import.fullname" . }}
      containers:
        - name: {{ .Chart.Name }}
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag | default .Chart.AppVersion }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          volumeMounts:
            - mountPath: /opt
              name: python-script
          {{- if .Values.debug }}
          command: ["bash","-c","kopf run /opt/capi-rancher-import.py --all-namespaces --standalone --liveness=http://0.0.0.0:8080/healthz --verbose"]
          {{- else }}
          command: ["bash","-c","kopf run /opt/capi-rancher-import.py --all-namespaces --standalone --liveness=http://0.0.0.0:8080/healthz"]
          {{ end }}
          env:
          {{- if hasKey .Values.conf "cattle_agent_kustomize_source_ref" }}
          - name: CATTLE_AGENT_KUSTOMIZATION_SOURCEREF_KIND
            value: {{ .Values.conf.cattle_agent_kustomize_source_ref.kind }}
          - name: CATTLE_AGENT_KUSTOMIZATION_SOURCEREF_NAME
            value: {{ .Values.conf.cattle_agent_kustomize_source_ref.name }}
          - name: CATTLE_AGENT_KUSTOMIZATION_SOURCEREF_NAMESPACE
            value: {{ .Values.conf.cattle_agent_kustomize_source_ref.namespace }}
          {{- else }}
          - name: CATTLE_AGENT_KUSTOMIZATION_SOURCEREF_KIND
            value: {{ .Values.conf.cattle_agent_kustomize_source.kind }}
          - name: CATTLE_AGENT_KUSTOMIZATION_SOURCEREF_NAME
            value: {{ include "capi-rancher-import.fullname" . }}-cattle-agent-kustomize
          - name: CATTLE_AGENT_KUSTOMIZATION_SOURCEREF_NAMESPACE
            value: {{ .Release.Namespace }}
          {{- end }}
          - name: CATTLE_AGENT_KUSTOMIZATION_PATH
            value: {{ .Values.conf.cattle_agent_kustomize_path }}
          {{- if .Values.conf.env }}
{{ toYaml .Values.conf.env | indent 10 }}
          {{- end }}
          livenessProbe:
            httpGet:
              path: /healthz
              port: 8080
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
